

#include <string>
#include <vector>
#include <Eigen/Dense>


#define MAXIMUM_NO_TRIES      100

#define TRUE  1
#define FALSE 0

/* general macros */

#define MAX(x,y)        ((x)>=(y)?(x):(y))
#define MIN(x,y)        ((x)<=(y)?(x):(y))

#define DEBUG( x )
#define VERYVERBOSE( x )

#define TRACE( x )

/* constants for a random number generator, for details see numerical recipes in C */

#define IA 16807
#define IM 2147483647
#define AM (1.0/IM)
#define IQ 127773
#define IR 2836
#define MASK 123459876


typedef Eigen::Matrix <long int, Eigen::Dynamic, 1> VectorXl;
typedef Eigen::Matrix <long int, Eigen::Dynamic, Eigen::Dynamic> MatrixXl;

extern long int seed;

double mean ( long int *values, long int max);

double meanr ( double *values, long int max );

double std_deviation ( long int *values, long int i, double mean );

double std_deviationr ( double *values, long int i, double mean );

long int best_of_vector ( long int *values, long int i );

double best_of_vectorr ( double *values, long int i );

long int worst_of_vector ( long int *values, long int i );

double worst_of_vectorr( double *values, long int l ) ;

void swap ( long int v[], long int i, long int j );

void sort ( long int v[], long int left, long int right );

double quantil ( long int vector[], double q, long int numbers );

void swap2(long int v[], long int v2[], long int i, long int j);

void sort2(long int v[], long int v2[], long int left, long int right);

double ran01 ( long *idum );

long int random_number ( long *idum );

long int ** generate_int_matrix( long int n, long int m);

double ** generate_double_matrix( long int n, long int m);

double phi(double x);

void addRow(MatrixXl& matrix, long int * new_row,  unsigned int indexAdd);

void addElement(VectorXl& vec, long int new_value,  unsigned int indexAdd);

void removeRow(MatrixXl& matrix,  unsigned int indexRemove);

void removeElement(VectorXl& vec, unsigned int indexRemove);
